package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.UsuarioEmpresaDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.entidad.UsuarioEmpresa;
import com.rjconsultores.ventaboletos.service.UsuarioEmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("usuarioEmpresaService")
public class UsuarioEmpresaServiceImpl implements UsuarioEmpresaService {

    @Autowired
    private UsuarioEmpresaDAO usuarioEmpresaDAO;

    public List<UsuarioEmpresa> obtenerTodos() {
        return usuarioEmpresaDAO.obtenerTodos();
    }

    public UsuarioEmpresa obtenerID(Integer id) {
        return usuarioEmpresaDAO.obtenerID(id);
    }

    @Transactional
    public UsuarioEmpresa suscribir(UsuarioEmpresa entidad) {
        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return usuarioEmpresaDAO.suscribir(entidad);
    }

    @Transactional
    public UsuarioEmpresa actualizacion(UsuarioEmpresa entidad) {
        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return usuarioEmpresaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(UsuarioEmpresa entidad) {
        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        usuarioEmpresaDAO.actualizacion(entidad);
    }

    public List<UsuarioEmpresa> obtenerPorUsuario(Usuario usuario) {
        return usuarioEmpresaDAO.obtenerPorUsuario(usuario);
    }
    
    public List<Empresa> obtenerEmpresa(Usuario usuario) {
        return usuarioEmpresaDAO.obtenerEmpresa(usuario);
    }
    
    public Boolean obtenerPorEmpresaUsuario(Empresa empresa, Usuario usuario) {
    	return usuarioEmpresaDAO.obtenerPorEmpresaUsuario( empresa, usuario);
    }
   
}

